<template>
  <div class="app-container" id="repairWarehousing">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="关键字" prop="keyWord">
        <el-input v-model="queryParams.keyWord" placeholder="请输入关键字" clearable maxlength="50" style="width: 240px"
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="维修时间">
        <el-date-picker v-model="queryParams.wxTime" style="width: 240px" value-format="yyyy-MM-dd" type="date"
          range-separator="-" placeholder="维修时间"></el-date-picker>
      </el-form-item>
      <el-form-item label="设备类型" prop="deviceTypeId">
        <el-select v-model="queryParams.deviceTypeId" placeholder="请选择设备类型" clearable filterable style="width: 240px">
          <el-option v-for="typeItem in typeList" :key="typeItem.typeId" :label="typeItem.typeName"
            :value="typeItem.typeId" />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="规格型号" prop="modelId">
        <el-select
          v-model="queryParams.modelId"
          placeholder="请选择规格型号"
          clearable
          style="width: 240px"
        >
          <el-option
            v-for="model in modelList"
            :key="model.typeId"
            :label="model.typeName"
            :value="model.typeId"
          />
        </el-select>
      </el-form-item>-->

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">查询</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          :disabled="single"
          @click="handleAdd"
          v-hasPermi="['system:dict:add']"
        >入库审核</el-button>
      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="success"-->
      <!--          plain-->
      <!--          icon="el-icon-edit"-->
      <!--          size="mini"-->
      <!--          :disabled="single"-->
      <!--          @click="handleUpdate"-->
      <!--          v-hasPermi="['system:dict:edit']"-->
      <!--        >修改</el-button>-->
      <!--      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="danger"-->
      <!--          plain-->
      <!--          icon="el-icon-delete"-->
      <!--          size="mini"-->
      <!--          :disabled="multiple"-->
      <!--          @click="handleDelete"-->
      <!--          v-hasPermi="['system:dict:remove']"-->
      <!--        >删除</el-button>-->
      <!--      </el-col>-->
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tableList">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
      <el-table-column label="维修单号" align="center" prop="repairCode" />
      <el-table-column label="工机具类型" align="center" prop="maTypeName" :show-overflow-tooltip="true" />
      <el-table-column label="维修人员" align="center" prop="wxName" :show-overflow-tooltip="true" />
      <el-table-column label="维修时间" align="center" prop="wxTime" :show-overflow-tooltip="true"></el-table-column>
      <!-- <el-table-column label="退料单号" align="center" prop="dictName" :show-overflow-tooltip="true" />

      <el-table-column label="提交入库人员" align="center" prop="updateBy" :show-overflow-tooltip="true" />
      <el-table-column label="提交入库时间" align="center" prop="updateTime" width="180"></el-table-column>
      <el-table-column label="不通过原因" align="center" prop="remark" :show-overflow-tooltip="true" />-->
      <el-table-column label="状态" align="center" prop="taskStatus">
        <!-- <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_normal_disable" :value="scope.row.status"/>
        </template>-->
      </el-table-column>

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" icon="el-icon-zoom-in" @click="handleView(scope.row)">查看</el-button>
          <el-button size="mini" type="primary" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-if="scope.row.taskStatus == '入库进行中'">审核</el-button>
          <!--          <el-button-->
          <!--            size="mini"-->
          <!--            type="text"-->
          <!--            icon="el-icon-delete"-->
          <!--            @click="handleDelete(scope.row)"-->
          <!--            v-hasPermi="['system:dict:remove']"-->
          <!--          >删除</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改参数配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body>
      <el-form :model="query" ref="query" size="small" :inline="true" v-show="showSearch" label-width="68px">
        <el-form-item label="关键字" prop="keyWord">
          <el-input v-model="query.keyWord" placeholder="请输入关键字" clearable maxlength="50" style="width: 240px"
            @keyup.enter.native="handleQuery" />
        </el-form-item>
        <!--        <el-form-item label="状态" prop="status"> -->
        <!--        <el-select -->
        <!--        v-model="query.status" -->
        <!--        placeholder="审核状态" -->
        <!--        clearable -->
        <!--        filterable -->
        <!--        style="width: 240px" -->
        <!--        > -->
        <!--        <el-option label="未审核" value="0" /> -->
        <!--        <el-option label="已入库" value="1" /> -->
        <!--        <el-option label="驳回" value="2" /> -->
        <!--        </el-select> -->
        <!--        </el-form-item> -->

        <el-form-item label="机具类型" prop="typeId">
          <treeselect v-model="query.typeId" default-expand-all :options="equipmentTypeList" placeholder="请选择规格型号"
            :disable-branch-nodes="true" style="width: 240px" noChildrenText="没有数据了" noOptionsText="没有数据"
            noResultsText="没有搜索结果" />
        </el-form-item>

        <!--        <el-form-item label="设备类型" prop="deviceTypeId"> -->
        <!--        <el-select -->
        <!--        v-model="query.deviceTypeId" -->
        <!--        placeholder="请选择设备类型" -->
        <!--        clearable -->
        <!--        filterable -->
        <!--        style="width: 240px" -->
        <!--        > -->
        <!--        <el-option -->
        <!--        v-for="typeItem in typeList" -->
        <!--        :key="typeItem.typeId" -->
        <!--        :label="typeItem.typeName" -->
        <!--        :value="typeItem.typeId" -->
        <!--        /> -->
        <!--        </el-select> -->
        <!--        </el-form-item> -->
        <!--        <el-form-item label="规格型号" prop="typeId"> -->
        <!--        <el-select -->
        <!--        v-model="query.typeId" -->
        <!--        placeholder="请选择规格型号" -->
        <!--        clearable -->
        <!--        filterable -->
        <!--        style="width: 240px" -->
        <!--        > -->
        <!--        <el-option -->
        <!--        v-for="model in modelList" -->
        <!--        :key="model.typeId" -->
        <!--        :label="model.typeName" -->
        <!--        :value="model.typeId" -->
        <!--        /> -->
        <!--        </el-select> -->
        <!--        </el-form-item> -->
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleDialogQuery">查询</el-button>
          <!-- <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button> -->
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button type="primary" plain size="mini" :disabled="multiple" @click="passAll">批量通过</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="danger" plain size="mini" @click="refusedAll" :disabled="multiple">批量不通过</el-button>
        </el-col>
        <!--        <el-col :span="1.5">-->
        <!--          <el-button-->
        <!--            type="warning"-->
        <!--            plain-->
        <!--            icon="el-icon-download"-->
        <!--            size="mini"-->
        <!--            @click="handleExport"-->
        <!--            v-hasPermi="['system:dict:export']"-->
        <!--          >导出</el-button>-->
        <!--        </el-col>-->
      </el-row>
      <el-table v-loading="loading" :data="detailTableList" @selection-change="handleSelectionChange" height="400">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="序号" align="center" width="80" type="index" :index="indexContinuation(queryParams.pageNum, queryParams.pageSize)">
          <!-- <template scope="scope">
            <span>{{ (queryParams.pageNum - 1) * 10 + scope.$index + 1 }}</span>
          </template> -->
        </el-table-column>
        <el-table-column label="设备类型" align="center" prop="typeName2" :show-overflow-tooltip="true" />
        <el-table-column label="规格型号" align="center" prop="typeName" :show-overflow-tooltip="true" />
        <el-table-column label="数量" align="center" prop="repairNum" :show-overflow-tooltip="true" />
        <el-table-column label="编号" align="center" prop="maCode" :show-overflow-tooltip="true" />
        <el-table-column label="提交入库人员" align="center" prop="updateBy" :show-overflow-tooltip="true" width="100" />
        <el-table-column label="提交入库时间" align="center" prop="updateTime" width="100"></el-table-column>

        <el-table-column label="状态" align="center" prop="status">
          <!-- <template slot-scope="scope">
            <span v-if="scope.row.status=='0'">未审核</span>
            <span v-if="scope.row.status=='1'">已入库</span>
            <span v-if="scope.row.status=='2'">驳回 </span>
          </template>-->
        </el-table-column>

        <el-table-column label="操作" align="center" class-name="small-padding fixed-width" v-if="showHandle">
          <template slot-scope="scope">
            <el-button size="mini" type="text" @click="pass(scope.row)" v-if="scope.row.status == '进行中'">通过</el-button>
            <el-button size="mini" type="text" v-if="scope.row.status == '进行中'"
              @click="refused(scope.row)">不通过</el-button>
            <!--          <el-button-->
            <!--            size="mini"-->
            <!--            type="text"-->
            <!--            icon="el-icon-delete"-->
            <!--            @click="handleDelete(scope.row)"-->
            <!--            v-hasPermi="['system:dict:remove']"-->
            <!--          >删除</el-button>-->
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="dialogTotal > 0" :total="dialogTotal" :page.sync="query.pageNum" :limit.sync="query.pageSize"
        @pagination="getDialogTable" />
    </el-dialog>
  </div>
</template>

<script>
import { listType, getType, delType, addType, updateType, refreshCache } from '@/api/system/dict/type'
import { getRepairedList, getRepairedDetailList, inputByType, getTypeList } from '@/api/store/warehousing'
import { equipmentTypeTree } from '@/api/store/tools'

import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'

export default {
  name: 'RepairWarehousing',
  dicts: ['sys_normal_disable'],
  components: {
    Treeselect,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 总条数
      dialogTotal: 0,
      //搜索下拉数据
      typeList: [],
      modelList: [],
      // 表格数据
      tableList: [],
      detailTableList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      showHandle: true,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        dictName: undefined,
        dictType: undefined,
        status: undefined,
        keyWord: '',
        wxTime: '',
        deviceTypeId: '',
      },
      query: {
        pageNum: 1,
        pageSize: 10,
        keyWord: '',
        typeId: ''
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        dictName: [
          {
            required: true,
            message: '字典名称不能为空',
            trigger: 'blur',
          },
        ],
        dictType: [
          {
            required: true,
            message: '字典类型不能为空',
            trigger: 'blur',
          },
        ],
      },
      equipmentTypeList: [],
    }
  },
  created() {
    this.getList()
    this.getTypeList()
    this.equipmentType()
  },
  methods: {
    getTypeList() {
      getTypeList({ level: '3' }).then(response => {
        this.typeList = response.data
      })
      getTypeList({ level: '4' }).then(response => {
        this.modelList = response.data
      })
    },
    /** 查询字典类型列表 */
    getList() {
      this.loading = true
      getRepairedList(this.queryParams).then(response => {
        this.tableList = response.rows
        this.total = response.total
        this.loading = false
      })
    },

    getDialogTable() {
      this.loading = true
      getRepairedDetailList(this.query).then(response => {
        this.detailTableList = response.rows
        this.dialogTotal = response.total
        this.loading = false
      })
    },

    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        dictId: undefined,
        dictName: undefined,
        dictType: undefined,
        status: '0',
        remark: undefined,
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 搜索按钮操作 */
    handleDialogQuery() {
      this.query.pageNum = 1
      this.getDialogTable()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      // this.reset();
      this.open = true
      this.title = '添加字典类型'
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      // this.reset();
      this.query.keyWord = ''
      this.query.taskId = row.id
      this.getDialogTable()
      this.open = true
      this.showHandle = true
      this.title = '审核'
    },
    //查看
    handleView(row) {
      this.query.keyWord = ''
      this.query.taskId = row.id
      this.getDialogTable()
      this.open = true
      this.showHandle = false
      this.title = '查看'
    },
    pass(row) {
      console.log(row)
      console.log(this.query.taskId)
      row.taskId = this.query.taskId
      let obj = {
        taskId: this.query.taskId,
        id: row.id,
        checkType: '1', //1 审核通过 2 驳回 -必填
        type: row.manageType, //0.编号 1.计数
        maId: row.maId,
        typeId: row.typeId,
        remark: row.remark,
        repairNum: row.repairNum,
      }

      let param = {
        params: JSON.stringify([obj]),
      }
      console.log(param)
      inputByType(param).then(response => {
        if (response.code == 200) {
          this.$modal.msgSuccess('审批成功')
          this.getDialogTable()
          this.getList()
        } else {
          this.$modal.msgSuccess('审批失败')
        }
      })
    },
    passAll() {
      console.log(this.query.taskId)
      console.log(this.ids)
      this.ids.forEach(item => {
        item.taskId = this.query.taskId
        item.checkType = '1'
        item.type = item.manageType //0.编号 1.计数
      })
      let param = {
        params: JSON.stringify(this.ids),
      }
      inputByType(param).then(response => {
        if (response.code == 200) {
          this.$modal.msgSuccess('审批成功')
          this.getDialogTable()
          this.getList()
        } else {
          this.$modal.msgSuccess('审批失败')
        }
      })
    },

    refused(row) {
      console.log(row)
      console.log(this.query.taskId)
      row.taskId = this.query.taskId
      let obj = {
        taskId: this.query.taskId,
        id: row.id,
        checkType: '2', //1 审核通过 2 驳回 -必填
        type: row.manageType, //0.编号 1.计数
        maId: row.maId,
        typeId: row.typeId,
        remark: row.remark,
        repairNum: row.repairNum,
      }
      let param = {
        params: JSON.stringify([obj]),
      }
      inputByType(param).then(response => {
        if (response.code == 200) {
          this.$modal.msgSuccess('审批成功')
          this.getDialogTable()
          this.getList()
        } else {
          this.$modal.msgSuccess('审批失败')
        }
      })
    },
    refusedAll() {
      console.log(this.query.taskId)
      console.log(this.ids)
      this.ids.forEach(item => {
        item.taskId = this.query.taskId
        item.checkType = '2'
        item.type = item.manageType
      })
      let param = {
        params: JSON.stringify(this.ids),
      }
      inputByType(param).then(response => {
        if (response.code == 200) {
          this.$modal.msgSuccess('审批成功')
          this.getDialogTable()
          this.getList()
        } else {
          this.$modal.msgSuccess('审批失败')
        }
      })
    },

    /** 提交按钮 */
    submitForm: function () {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.dictId != undefined) {
            updateType(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addType(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      // const dictIds = row.dictId || this.ids;
      // this.$modal.confirm('是否确认删除字典编号为"' + dictIds + '"的数据项？').then(function() {
      //   return delType(dictIds);
      // }).then(() => {
      //   this.getList();
      //   this.$modal.msgSuccess("删除成功");
      // }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'material/RepairTestInput/export',
        {
          ...this.queryParams,
        },
        `修试入库_${new Date().getTime()}.xlsx`
      )
    },
    /** 刷新缓存按钮操作 */
    handleRefreshCache() {
      refreshCache().then(() => {
        this.$modal.msgSuccess('刷新成功')
        this.$store.dispatch('dict/cleanDict')
      })
    },
    //规格型号
    equipmentType() {
      equipmentTypeTree().then(response => {
        this.equipmentTypeList = response.data
        this.equipmentTypeList.forEach((item, index) => {
          if (item.children && item.children.length > 0) {
            item.children.forEach((item2, index2) => {
              if (item2.children && item2.children.length > 0) {
                item2.children.forEach(item3 => {
                  if (item3.children && item3.children.length > 0) {
                    item3.children.forEach(item4 => {
                      item4.machineTypeName = item3.typeName
                      item4.specificationType = item4.typeName
                      // this.$set(item4, 'purchasePrice', 0);
                      // this.$set(item4, 'purchaseNum', 1);
                    })
                  }
                })
              }
            })
          }
        })
      })
    },
  },
}
</script>
<style lang="scss" scoped>
::v-deep.el-table .fixed-width .el-button--mini {
  width: 60px !important;
  margin-bottom: 10px;
}
</style>
